from flask import Flask, request, jsonify , render_template, redirect
import os
from flask_mysqldb import MySQL
import yaml
import model
import numpy as np

# init app
app = Flask(__name__)

# Configure db
db = yaml.load(open('db.yaml')) # Load data from db.yaml file
app.config['MYSQL_HOST'] = db['mysql_host']
app.config['MYSQL_USER'] = db['mysql_user']
app.config['MYSQL_PASSWORD'] = db['mysql_password']
app.config['MYSQL_DB'] = db['mysql_db']

mysql = MySQL(app)

@app.route('/progress/<uniqueId>', methods = ['get'])
def calculate_progress(uniqueId):

    gradient_list = []
    #Create connection to MYSql
    cur = mysql.connection.cursor()

    #get paper numbers of the student
    cur.execute("SELECT PAPER_NO FROM paper_result_student_final WHERE UNIQUE_ID="+uniqueId)
    paper_no_list = [item[0] for item in cur.fetchall()] # Fetched data add to the list

    for i in range(0, len(paper_no_list)): # get paper number one by one
        #Initialize list
        weight_list = []
        time_list = []
        time_list_new = []

        #get WEIGHT using id and paper number
        cur.execute("SELECT WEIGHT FROM paper_result_student WHERE UNIQUE_ID= " + uniqueId + " AND PAPER_NO= " + str(paper_no_list[i]))
        weight_list = [item[0] for item in cur.fetchall()]
        for w in range(0, len(weight_list)): 
            weight_list[i] = int(weight_list[w]) #convert string to int

        #get TIME using id and paper number
        cur.execute("SELECT TIME FROM paper_result_student WHERE UNIQUE_ID= " + uniqueId + " AND PAPER_NO= " + str(paper_no_list[i]))
        time_list  = [item[0] for item in cur.fetchall()] #Tuple convert toList
        for t in range(0, len(time_list)): 
            (h, m, s) = time_list[t].split(':') #Time split to decimal number
            time_in_decimal = int(h) * 3600 + int(m) * 60 + int(s)
            time_list_new.append(time_in_decimal)

        #pass weight_list and time_list_new to the Machine learning MODEL and get gradient
        gradient = model.calculateGradientLinerRegressionAndSVR(weight_list ,  time_list_new)
        gradient_list.append(float(gradient)) #Gradient convert to float and add to the list

    #Close the db connections
    cur.close()

    #gradient_list Convert to numpy array
    arr = np.array(gradient_list)
    print(arr.tolist())
    return({'learningProgresList': arr.tolist()})

    # return render_template('index2.html', students=data )

# Run Server
if __name__ == '__main__':
    app.run(debug=True)
