import React, { Component } from 'react';
import { withRouter, Redirect } from 'react-router-dom';
import axios from 'axios';
import constant from '../service/constant';



class ExamSearch extends Component {

    constructor(pros) {
        super(pros)

        this.state = {
            SystemUser: this.props.SystemUser,
            areaList: [],
            topicList: [],
            subTopicList: [],
            questionList: [],
            area: '',
            topic: '',
            subtopic: '',
            value: false,
        }
    }

    componentDidMount() {
        axios.get(constant() + '/searchlist')
            .then(res => {
                this.setState({
                    areaList: res.data.areaList,
                    topicList: res.data.topicList,
                    subTopicList: res.data.subTopicList,
                    area: res.data.areaList[0],
                    topic: res.data.topicList[0],
                    subtopic: res.data.subTopicList[0],
                });
                console.log(this.state.areaList);
            }).catch(err => {
                console.log(err);
            });
    }

    listHandler = (e) => {
        const state = this.state
        state[e.target.name] = e.target.value;
        this.setState(state)
    }

    redirect_fun(questionList , SystemUser) {

        return <Redirect
            to={{
                pathname: "/QuestionPaper",
                state: {
                    questionList: questionList,
                    answerList: [],
                    SystemUser: SystemUser,
                    count: 0,
                    paperCount: 1,
                }
            }}
        />
    
    }

    generatePaperHandler = (e) => {
        e.preventDefault()
        var area = this.state.area;
        var topic = this.state.topic;
        var subtopic = this.state.subtopic;

        axios.post(constant() + '/questions/' + area + '/' + topic + '/' + subtopic + '/')
            .then(response => {
                console.log(response.data)
                this.state.questionList = response.data
                this.props.history.push({
                    pathname: '/QuestionPaper',
                    state: {
                        questionList: response.data,
                        answerList: [],
                        SystemUser: this.state.SystemUser,
                        count: 0,
                        paperCount: 1,
                    }
                });


            })
            .catch(error => {
                console.log(error)
            })
    }


    render() {

        const { area, topic, subtopic } = this.state;


        return (

            <div className="container">
                <div className="panel panel-default">
                    <div className="panel-heading">
                        <h3 className="panel-title">
                            Student exam page
              </h3>
                    </div>
                    <div className="panel-body">
                        <form onSubmit={this.submitHandler}>
                            <div className="form-group">
                                <label>Area:</label>
                                <select className="form-control" name="area" onChange={this.listHandler} value={area}>
                                    {
                                        this.state.areaList.map(sub => {
                                            return (
                                                <option key={sub.id} value={sub.id}>{sub} </option>
                                            )
                                        })
                                    }
                                </select>
                            </div>
                            <div className="form-group">
                                <label>Topic:</label>
                                <select className="form-control" name="topic" onChange={this.listHandler} value={topic}>
                                    {
                                        this.state.topicList.map(sub => {
                                            return (
                                                <option key={sub.id} value={sub.id}>{sub} </option>
                                            )
                                        })
                                    }
                                </select>
                            </div>
                            <div className="form-group">
                                <label>Sub Topic:</label>
                                <select className="form-control" name="subtopic" onChange={this.listHandler} value={subtopic}>
                                    {
                                        this.state.subTopicList.map(sub => {
                                            return (
                                                <option key={sub.id} value={sub.id}>{sub} </option>
                                            )
                                        })
                                    }
                                </select>
                            </div>
                            <button type="submit" className="btn btn btn-outline-success registerBtn" onClick={this.generatePaperHandler.bind(this)}>Genarate</button>
                            <button type="button" className="btn btn-outline-secondary loginBtn">Reset</button>
                        </form>
                    </div>
                </div>
            </div>
        )
    }
}

export default withRouter(ExamSearch);
