import React, { Component } from 'react'
import { Link, withRouter, BrowserRouter as Router, Route } from 'react-router-dom';
import axios from 'axios'
import constant from '../service/constant';
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { faSignOutAlt, faAngleDoubleLeft, faEye, faCogs } from '@fortawesome/free-solid-svg-icons';

class papers extends Component {

    constructor(props) {
        super(props);

        this.state = {
            SystemUser: this.props.location.state.SystemUser,
            studentPaperList: [],
        }
    }

    componentDidMount() {
        var sid = this.state.SystemUser.systemUser.id;

        axios.get(constant() + '/getpapers/' + sid + '/')
            .then(res => {
                this.setState({ studentPaperList: res.data });
            }).catch(err => {
                console.log(err);
            });


        // var html_code = '<button style={{ marginLeft: "10px" }} onClick={() => this.viewPaper(paper.sid, paper.paperNo, paper.subtopic)} className="btn btn-outline-secondary">View </button>';

        // if (true) {
        //     document.getElementById("continueBtn").innerHTML = html_code;
        // } 
    }

    logOutButtonHandler = () => {
        this.props.history.push("/")
    }

    backButtonHandler = () => {
        this.props.history.push({
            pathname: '/StudentDashBoard',
            state: {
                SystemUser: this.state.SystemUser,
            }
        });

    }

    viewPaper = (id) => {

        axios.get(constant() + '/getpaper/' + id + '/')
            .then(res => {
                this.setState({
                    questionList: res.data.questionList,
                    answerList: res.data.answerList,
                });
                this.props.history.push({
                    pathname: '/QuestionPaperResultsView',
                    state: {
                        SystemUser: this.state.SystemUser,
                        questionList: res.data.questionList,
                        answerList: res.data.answerList,
                    }
                });

            }).catch(err => {
                console.log(err);
            });
    }

    generatePaperHandler = (id, paperNo, area, topic, subtopic, uniqueId) => {
        var paperNo = paperNo
        var area = area;
        var topic = topic;
        var subtopicNew = subtopic.split(','); //String-list convert to List

        axios.post(constant() + '/questions/' + area + '/' + topic + '/', subtopicNew)
            .then(response => {
                console.log(response.data)
                this.props.history.push({
                    pathname: '/QuestionPaper',
                    state: {
                        questionList: response.data,
                        answerList: [],
                        SystemUser: this.state.SystemUser,
                        count: 0,
                        paperNo: paperNo + 1,
                        area: area,
                        topic: topic,
                        subtopic: subtopicNew,
                        previouPaperId: id,
                        uniqueId: uniqueId,
                    }
                });

            })
            .catch(error => {
                console.log(error)
            })

    }

    // getContinueBtn = (flag) => {
    //     var html_code = '<button style={{ marginLeft: "10px" }} onClick={() => this.viewPaper(paper.sid, paper.paperNo, paper.subtopic)} className="btn btn-outline-secondary">View </button>';

    //     if (flag == 'ACTIVE') {
    //         document.getElementById("continueBtn").innerHTML = html_code;
    //     } 
    // }

    render() {

        // function getSubjectList(flag) {
        //     var html_code = '<button style={{ marginLeft: "10px" }} onClick={() => this.viewPaper(paper.sid, paper.paperNo, paper.subtopic)} className="btn btn-outline-secondary">View </button>';

        //     if (flag == 'ACTIVE') {
        //         document.getElementById("continueBtn").innerHTML = html_code;
        //     } 
        // }

        return (
            <div className="container">
                <div className="panel panel-default">
                    <div className="panel-heading">
                        <div className="row">
                            <div className="col-md-7">
                                <h3 className="panel-title">
                                    Student Papers
                </h3>
                            </div>
                            <div className="col-md-3 text-right">
                                <button type="submit" className="btn btn btn-outline-primary" onClick={this.backButtonHandler.bind(this)}><FontAwesomeIcon icon={faAngleDoubleLeft} />  Back to Dashboard</button>
                            </div>
                            <div className="col-md-2">
                                <button type="submit" className="btn btn btn-outline-danger" onClick={this.logOutButtonHandler.bind(this)}><FontAwesomeIcon icon={faSignOutAlt} />  Logout</button>
                            </div>
                        </div>
                    </div><br />
                    <div className="panel-body">
                        <table class="table table-striped">
                            <thead>
                                <tr>
                                    <th scope="col">Attempt</th>
                                    <th scope="col">Area</th>
                                    <th scope="col">Topic</th>
                                    <th scope="col">Sub Topic</th>
                                    <th scope="col">Date/Time</th>
                                    <th scope="col">Avarege Mark</th>
                                    <th scope="col"></th>
                                    <th scope="col"></th>
                                </tr>
                            </thead>
                            <tbody>
                                {
                                    this.state.studentPaperList.map(
                                        paper =>

                                            <tr>
                                                <td>{paper.paperNo}</td>
                                                <td>{paper.area}</td>
                                                <td>{paper.topic}</td>
                                                {/* <td><b>{paper.subtopic}</b>-({paper.uniqueId})</td> */}
                                                <td>{paper.subtopic}</td>
                                                <td>{paper.date}</td>
                                                <td>{paper.averageScore}%</td>
                                                <td>
                                                    <button disabled={!(paper.flag == "ACTIVE")} style={{ marginLeft: "10px" }} onClick={() => this.generatePaperHandler(paper.id, paper.paperNo, paper.area, paper.topic, paper.subtopic, paper.uniqueId)} className="btn btn-outline-success"><FontAwesomeIcon icon={faCogs} /> Continue</button>
                                                    {/* <p id="continueBtn" onChange={() => this.getContinueBtn(paper.flag)}></p> */}
                                                </td>
                                                <td>
                                                    <button style={{ marginLeft: "10px" }} onClick={() => this.viewPaper(paper.id)} className="btn btn-outline-info"><FontAwesomeIcon icon={faEye} /> View </button>
                                                </td>
                                            </tr>
                                    )
                                }
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>


        )
    }
}

export default papers 
