import React, { Component } from 'react'
import axios from 'axios'
import constant from '../service/constant';
// import moment from 'react-moment'
import moment from 'moment';
import Clock from 'react-live-clock';
import Timer from 'react-compound-timer'
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { faArrowAltCircleRight } from '@fortawesome/free-solid-svg-icons';

class QuestionPaper extends Component {

    constructor(pros) {
        super(pros)

        this.state = {
            questionList: this.props.location.state.questionList,
            answerList: this.props.location.state.answerList,
            count: this.props.location.state.count,
            paperNo: this.props.location.state.paperNo,
            SystemUser: this.props.location.state.SystemUser,
            area:this.props.location.state.area,
            topic:this.props.location.state.topic,
            subtopic:this.props.location.state.subtopic,
            previouPaperId: this.props.location.state.previouPaperId,
            uniqueId: this.props.location.state.uniqueId,
            subtopicNew:'',
            studentAnswer: 0,
            startTime: 0,

        }
    }

    componentDidMount() {
        const { startTime } = this.state;
        //get current time (START TIME)
        var startTimeNew = moment().utcOffset('+05:30').format('YYYY-MM-DD hh:mm:ss a');
        //set the subtopic lis to string
        var subtopicNew = this.state.subtopic[0]; //initially add the first subtopic to the string
        this.state.subtopic.map(function (subTopic, index) {
            if(index != 0){ //after first repeatly add rest of the subtopic
                subtopicNew = subtopicNew.concat(", "+ subTopic)
            }
          })
        console.log(startTimeNew)
        this.setState({ startTime: startTimeNew,subtopicNew:subtopicNew  })
    }

    changeHandler = (e) => {
        this.setState({ [e.target.name]: e.target.value })
    }

    submitHandler = (e) => {
        e.preventDefault()
        const { count, studentAnswer, questionList, answerList, startTime, SystemUser, paperNo, area, topic, subtopic, previouPaperId, uniqueId } = this.state;

        //Cheke the answer is selected
        if (studentAnswer != 0) {

            //get current time (END TIME)
            var endTime = moment().utcOffset('+05:30').format('YYYY-MM-DD hh:mm:ss a');
            //Calculate the diffrent
            var timeConsuming = moment.utc(moment(endTime, "YYYY/MM/DD HH:mm:ss a").diff(moment(startTime, "YYYY/MM/DD HH:mm:ss a"))).format("HH:mm:ss")

            var answerObj = {
                questionId: questionList[count].id,
                weight: questionList[count].weight,
                studentAnswer: studentAnswer,
                correctAnswer: questionList[count].correctAnswer,
                time: timeConsuming,
            }

            answerList.push(answerObj);

            if (count < questionList.length - 1) {
                //Increase count for next question
                this.setState({ count: count + 1, studentAnswer: 0 })

                //get current time (START TIME)
                var startTimeNew = moment().utcOffset('+05:30').format('YYYY-MM-DD hh:mm:ss a');
                this.setState({ startTime: startTimeNew })

                //Unchecked the radio buttons
                document.getElementById("ans1").checked = false;
                document.getElementById("ans2").checked = false;
                document.getElementById("ans3").checked = false;
                document.getElementById("ans4").checked = false;
            } else {
                this.props.history.push({
                    pathname: '/QuestionPaperResults',
                    state: {
                        questionList: questionList,
                        answerList: answerList,
                        SystemUser: SystemUser,
                        paperNo: paperNo,
                        area:area,
                        topic:topic,
                        subtopic:subtopic,
                        previouPaperId:previouPaperId,
                        uniqueId:uniqueId,
                    }
                });
            }
        } else if (studentAnswer == 0) {
            alert("You should select a answer");
        }

    }


    render() {

        const { count, questionList, studentAnswer } = this.state;

        return (
            <div className="container">
                <div className="panel panel-default">
                    <div className="panel-heading">
                        <h3 className="panel-title">
                            <div className="row">
                                <div className="col-sm-12 text-center">
                                    Question Paper - {this.state.area} <br /><h5> Topic -  {this.state.topic} </h5><h5>  Sub Topic - {this.state.subtopicNew}</h5>
                                </div>
                            </div>
                        </h3>
                        <div className="row">
                            <div className="col-sm-8">
                            </div>
                            <div className="col-sm-4">
                                <h5>
                                    <Timer>
                                        {() => (
                                            <React.Fragment>
                                                <Timer.Hours /> Hour :
                                                <Timer.Minutes /> Minute :
                                                <Timer.Seconds /> Seconds
                                            </React.Fragment>
                                        )}
                                    </Timer>
                                </h5>
                            </div>
                        </div>

                    </div>
                    <div className="panel-body">
                        <form onSubmit={this.submitHandler}>
                            <div className="card">
                                <div className="card-header"><lable>{count + 1}. </lable><lable>{questionList[count].question} {questionList[count].correctAnswer}</lable></div>
                                <div className="card-body">
                                    <div className="form-group">
                                        <input type="radio" value="1" id='ans1' name="studentAnswer" onChange={this.changeHandler} /> <lable> a) </lable>{questionList[count].answer1}
                                    </div>
                                    <div className="form-group">
                                        <input type="radio" value="2" id='ans2' name="studentAnswer" onChange={this.changeHandler} /> <lable> b) </lable>{questionList[count].answer2}
                                    </div>
                                    <div className="form-group">
                                        <input type="radio" value="3" id='ans3' name="studentAnswer" onChange={this.changeHandler} /> <lable> c) </lable>{questionList[count].answer3}
                                    </div>
                                    <div className="form-group">
                                        <input type="radio" value="4" id='ans4' name="studentAnswer" onChange={this.changeHandler} /> <lable> d) </lable>{questionList[count].answer4}
                                    </div>
                                    <button type="submit" className="btn btn btn-outline-success registerBtn">Next &nbsp; <FontAwesomeIcon icon={faArrowAltCircleRight} />  </button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>

        )
    }
}

export default QuestionPaper;
