import React, { Component } from 'react'
import axios from 'axios'
import constant from '../service/constant';
import moment from 'moment';
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { faFastBackward } from '@fortawesome/free-solid-svg-icons';
import { CircularProgressbar } from "react-circular-progressbar";

function QuestionListView(props) {
    const questionList = props.questionList;
    const answerList = props.answerList;

    const listItems = questionList.map((question, key) =>
        <div>
            <div className="card">
                <div className="card-header"><lable>{key + 1}. </lable><lable>{question.question}</lable></div>
                <div className="card-body">
                    <p className="card-text">{answer1(question, answerList[key])}</p>
                    <p className="card-text">{answer2(question, answerList[key])}</p>
                    <p className="card-text">{answer3(question, answerList[key])}</p>
                    <p className="card-text">{answer4(question, answerList[key])}</p>
                </div>
            </div><br />
        </div>
    );
    return (
        <ul className="card-list-align">{listItems}</ul>
    );
}

function answer1(question, correctAnswer) {

    if (correctAnswer.studentAnswer == 1 && correctAnswer.correctAnswer == 1) {
        const listItems =
            <div>
                <div className="alert alert-success">
                    <lable> a) </lable>{question.answer1}
                </div>
            </div>
        return listItems;
    } else if (correctAnswer.studentAnswer == 1 && correctAnswer.correctAnswer != 1) {
        const listItems =
            <div>
                <div className="alert alert-danger">
                    <lable> a) </lable>{question.answer1}
                </div>
            </div>
        return listItems;
    } else if (correctAnswer.studentAnswer != 1 && correctAnswer.correctAnswer == 1) {
        const listItems =
            <div>
                <div className="alert alert-success">
                    <lable> a) </lable>{question.answer1}
                </div>
            </div>
        return listItems;
    } else {
        const listItems =
            <div>
                <div className="alert">
                    <lable> a) </lable>{question.answer1}
                </div>
            </div>
        return listItems;
    }


}

function answer2(question, correctAnswer) {

    if (correctAnswer.studentAnswer == 2 && correctAnswer.correctAnswer == 2) {
        const listItems =
            <div>
                <div className="alert alert-success">
                    <lable> b) </lable>{question.answer2}
                </div>
            </div>
        return listItems;
    } else if (correctAnswer.studentAnswer == 2 && correctAnswer.correctAnswer != 2) {
        const listItems =
            <div>
                <div className="alert alert-danger">
                    <lable> b) </lable>{question.answer2}
                </div>
            </div>
        return listItems;
    } else if (correctAnswer.studentAnswer != 2 && correctAnswer.correctAnswer == 2) {
        const listItems =
            <div>
                <div className="alert alert-success">
                    <lable> b) </lable>{question.answer2}
                </div>
            </div>
        return listItems;
    } else {
        const listItems =
            <div>
                <div className="alert">
                    <lable> b) </lable>{question.answer2}
                </div>
            </div>
        return listItems;
    }


}

function answer3(question, correctAnswer) {

    if (correctAnswer.studentAnswer == 3 && correctAnswer.correctAnswer == 3) {
        const listItems =
            <div>
                <div className="alert alert-success">
                    <lable> c) </lable>{question.answer3}
                </div>
            </div>
        return listItems;
    } else if (correctAnswer.studentAnswer == 3 && correctAnswer.correctAnswer != 3) {
        const listItems =
            <div>
                <div className="alert alert-danger">
                    <lable> c) </lable>{question.answer3}
                </div>
            </div>
        return listItems;
    } else if (correctAnswer.studentAnswer != 3 && correctAnswer.correctAnswer == 3) {
        const listItems =
            <div>
                <div className="alert alert-success">
                    <lable> c) </lable>{question.answer3}
                </div>
            </div>
        return listItems;
    } else {
        const listItems =
            <div>
                <div className="alert">
                    <lable> c) </lable>{question.answer3}
                </div>
            </div>
        return listItems;
    }


}

function answer4(question, correctAnswer) {

    if (correctAnswer.studentAnswer == 4 && correctAnswer.correctAnswer == 4) {
        const listItems =
            <div>
                <div className="alert alert-success">
                    <lable> d) </lable>{question.answer4}
                </div>
            </div>
        return listItems;
    } else if (correctAnswer.studentAnswer == 4 && correctAnswer.correctAnswer != 4) {
        const listItems =
            <div>
                <div className="alert alert-danger">
                    <lable> d) </lable>{question.answer4}
                </div>
            </div>
        return listItems;
    } else if (correctAnswer.studentAnswer != 4 && correctAnswer.correctAnswer == 4) {
        const listItems =
            <div>
                <div className="alert alert-success">
                    <lable> d) </lable>{question.answer4}
                </div>
            </div>
        return listItems;
    } else {
        const listItems =
            <div>
                <div className="alert">
                    <lable> d) </lable>{question.answer4}
                </div>
            </div>
        return listItems;
    }
}


class QuestionPaperResults extends Component {

    constructor(pros) {
        super(pros)

        this.state = {
            questionList: this.props.location.state.questionList,
            answerList: this.props.location.state.answerList,
            SystemUser: this.props.location.state.SystemUser,
            paperNo: this.props.location.state.paperNo,
            area: this.props.location.state.area,
            topic: this.props.location.state.topic,
            subtopic: this.props.location.state.subtopic,
            previouPaperId: this.props.location.state.previouPaperId,
            uniqueId: this.props.location.state.uniqueId,
            totalQuestionNo: 0,
            correctQuestionNo: 0,
            averageScore: 0,
            status: '',
            grade: '',
            date: '',
        }
    }

    componentDidMount() {
        const { answerList } = this.state;

        //get total no of questions
        var totalQuestionNoNew = answerList.length
        var correctQuestionNoNew = 0;
        var gradeNew = '';
        var statusNew = '';

        //calculate correct no of questiona
        answerList.map(function (answerObj) {
            if (parseInt(answerObj.studentAnswer) == answerObj.correctAnswer) {
                correctQuestionNoNew++;
            }
        });

        //Calculate correct answer percentage
        var averageScoreNew = (100 * correctQuestionNoNew) / totalQuestionNoNew;
        averageScoreNew = parseInt(averageScoreNew.toFixed(2));
        //Set the success level
        if (averageScoreNew >= 0 && averageScoreNew <= 20) {
            statusNew = 'Poor';
        } else if (averageScoreNew >= 21 && averageScoreNew <= 40) {
            statusNew = 'Faire';
        } else if (averageScoreNew >= 41 && averageScoreNew <= 60) {
            statusNew = 'Good';
        } else if (averageScoreNew >= 61 && averageScoreNew <= 80) {
            statusNew = 'Very Good';
        } else if (averageScoreNew >= 81 && averageScoreNew <= 100) {
            statusNew = 'Excellent';
        }

        //Set the grade
        if (averageScoreNew >= 0 && averageScoreNew <= 29) {
            gradeNew = 'E';
        } else if (averageScoreNew >= 30 && averageScoreNew <= 34) {
            gradeNew = 'D';
        } else if (averageScoreNew >= 35 && averageScoreNew <= 39) {
            gradeNew = 'D+';
        } else if (averageScoreNew >= 40 && averageScoreNew <= 44) {
            gradeNew = 'C-';
        } else if (averageScoreNew >= 45 && averageScoreNew <= 49) {
            gradeNew = 'C';
        } else if (averageScoreNew >= 50 && averageScoreNew <= 54) {
            gradeNew = 'C+';
        } else if (averageScoreNew >= 55 && averageScoreNew <= 59) {
            gradeNew = 'B-';
        } else if (averageScoreNew >= 60 && averageScoreNew <= 64) {
            gradeNew = 'B';
        } else if (averageScoreNew >= 65 && averageScoreNew <= 69) {
            gradeNew = 'B+';
        } else if (averageScoreNew >= 70 && averageScoreNew <= 74) {
            gradeNew = '-A';
        } else if (averageScoreNew >= 75 && averageScoreNew <= 84) {
            gradeNew = 'A';
        } else if (averageScoreNew >= 85 && averageScoreNew <= 100) {
            gradeNew = 'A+';
        }

        //get current date
        var dateNew = moment().utcOffset('+05:30').format('YYYY-MM-DD hh:mm:ss a');

        this.setState({
            totalQuestionNo: totalQuestionNoNew,
            correctQuestionNo: correctQuestionNoNew,
            averageScore: averageScoreNew,
            grade: gradeNew,
            status: statusNew,
            date: dateNew,
        });

    }


    submitHandler = (e) => {
        e.preventDefault()
        const { answerList, SystemUser, paperNo, totalQuestionNo, correctQuestionNo, averageScore, grade, status, area, topic, subtopic, date, previouPaperId, uniqueId } = this.state;
        // var subtopicNew = subtopic.split(','); //String-list convert to List
        var PaperResult = {
            loginResponse: SystemUser,
            studentAnswerList: answerList,
            paperNo: paperNo,
            totalQuestionNo: totalQuestionNo,
            correctQuestionNo: correctQuestionNo,
            averageScore: averageScore,
            grade: grade,
            status: status,
            area: area,
            topic: topic,
            subtopic: subtopic,
            date: date,
            previouPaperId: previouPaperId,
            uniqueId: uniqueId,
        }

        axios.post(constant() + '/paperresult', PaperResult)
            .then(response => {
                console.log(response)
                this.props.history.push({
                    pathname: '/StudentDashBoard',
                    state: {
                        SystemUser: this.state.SystemUser,
                    }
                });
            })
            .catch(error => {
                console.log(error)
            })

    }


    render() {

        const { questionList, answerList, correctQuestionNo, totalQuestionNo, averageScore, grade, status } = this.state;

        return (
            <div className="container">
                <div className="panel panel-default">
                    <div className="panel-heading">
                        <h3 className="panel-title text-center">
                            Question paper Final results
                        </h3><br />
                    </div>
                    <div className="panel-body">
                        <div className="row">
                            <div className="col-md-3">
                                <div className="card text-white bg-info mb-3 result-card">
                                    <div className="card-header">Marks</div>
                                    <div className="card-body">
                                        <h5 className="card-title text-center"><h1>{correctQuestionNo}/{totalQuestionNo}</h1></h5>
                                        <h5 className="card-title text-center">{correctQuestionNo} correct out of {totalQuestionNo}</h5>
                                    </div>
                                </div>
                            </div>
                            <div className="col-md-3">
                                <div className="card result-card">
                                    <div className="card-header">Average Score</div>
                                    <div className="card-body round-Progress">
                                        <div style={{ width: " 120px" }}>
                                            &nbsp;&nbsp;<CircularProgressbar value={averageScore} text={`${averageScore}%`} />
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div className="col-md-3">
                                <div className="card text-white bg-success mb-3 result-card">
                                    <div className="card-header">Status</div>
                                    <div className="card-body">
                                        <h5 className="card-title">Your knowledge level is </h5>
                                        <p className="card-text"><h3>{status}</h3></p>
                                    </div>
                                </div>

                            </div>
                            <div className="col-md-3">
                                <div className="card text-white bg-primary mb-3 result-card">
                                    <div className="card-header">Grade</div>
                                    <div className="card-body">
                                        <h5 className="card-title">Your Grade is</h5>
                                        <p className="card-text text-center"><h1>{grade}</h1></p>
                                    </div>
                                </div>

                            </div>
                        </div>
                        <form onSubmit={this.submitHandler}>
                            <QuestionListView questionList={questionList} answerList={answerList} />
                            <button type="submit" className="btn btn btn-outline-success"> <FontAwesomeIcon icon={faFastBackward} /> &nbsp; Submit and Back to DashBoard</button>
                        </form>
                    </div>
                </div>
            </div >

        )
    }
}

export default QuestionPaperResults;
