import React, { Component } from 'react'
import axios from 'axios'
import constant from '../service/constant';
import Card from 'react-bootstrap/Card'
import { makeStyles } from '@material-ui/core/styles';
import GridList from '@material-ui/core/GridList';
import GridListTile from '@material-ui/core/GridListTile';

class Student extends Component {

  constructor(pros) {
    super(pros)

    this.state = {
      postList: [],
      count: 0,
    }
  }

  componentWillMount() {
    axios.get(constant() + '/post')
      .then(res => {
        this.setState({ postList: res.data });
      }).catch(err => {
        console.log(err);
      });
  }

  render() {

    const { postList } = this.state;

    const classes = makeStyles((theme) => ({
      root: {
        display: 'flex',
        flexWrap: 'wrap',
        justifyContent: 'space-around',
        overflow: 'hidden',
        backgroundColor: theme.palette.background.paper,
      },
      gridList: {
        width: 500,
        height: 450,
      },
    }));

    return (
      <div className="container">
        <div className="panel panel-default">
          <div className="panel-heading">
            <h3 className="panel-title">
              Login
              </h3>
          </div>
          <div className="panel-body">
            <div className={classes.root}>
              <GridList cellHeight={500} className={classes.gridList} cols={3}>
                {postList.map((item) => (
                  <GridListTile key={item.img} cols={item.cols || 1}>
                    <Card>
                      <Card.Img className="postImageSize" variant="top" src={item.image} />
                      <Card.Body>
                        <Card.Title>{item.title}</Card.Title>
                        <Card.Text>{item.content} </Card.Text>
                      </Card.Body>
                      <Card.Footer>
                        <a href="#" class="btn btn-primary">Go somewhere</a>
                      </Card.Footer>
                    </Card>
                  </GridListTile>
                ))}
              </GridList>
            </div>
          </div>
        </div>
      </div>

    )
  }
}

export default Student;
