import React, { Component } from 'react'
import axios from 'axios'
import constant from '../service/constant';
import { faAngleDoubleLeft, faRedoAlt, faCogs, faSignOutAlt } from "@fortawesome/free-solid-svg-icons";
import { FontAwesomeIcon } from "@fortawesome/react-fontawesome";
import { MultiSelect } from '@progress/kendo-react-dropdowns';

const sports = ["Baseball", "Basketball", "Cricket", "Field Hockey", "Football", "Table Tennis", "Tennis", "Volleyball"];

class Student2 extends Component {

  constructor(pros) {
    super(pros)
    this.state = {
      SystemUser: this.props.location.state.SystemUser,
      areaList: [],
      topicList: [],
      subTopicList: [],
      questionList: [],
      subTopicListNew: ['Layer'],
      area: '',
      topic: '',
      subtopic: [],
      previouPaperId: 0,
      uniqueId: 0,

    }
  }

  componentDidMount() {
    axios.get(constant() + '/searchlist')
      .then(res => {

        // this.state.subtopic.push(res.data.subTopicList[0]) //add first sub topic to the list for view
        //Set the sub topic to new array
        // if (this.state.topicList[0] == this.state.topic) {
        //   this.state.subTopicListNew.push(subTopic[2])
        // }

        //Set the relevant sub topics accourding to the topic
        var subTopicListNew = [];
        res.data.subTopicList.map(function (subTopic, index) {
          if (res.data.topicList[0] == res.data.topicList[0]) {
            subTopicListNew.push(subTopic[0])
          }
        })


        this.setState({
          areaList: res.data.areaList,
          topicList: res.data.topicList,
          subTopicList: res.data.subTopicList,
          area: res.data.areaList[0],
          topic: res.data.topicList[0],
          subTopicListNew: subTopicListNew,
          // subtopic: res.data.subTopicList[0],
        });


        console.log(this.state.subTopicListNew);
      }).catch(err => {
        console.log(err);
      });
  }

  listHandler = (e) => {
    const state = this.state
    state[e.target.name] = e.target.value;
    this.setState(state)
  }

  topicHandler = (e) => {
    const state = this.state
    state[e.target.name] = e.target.value;
    this.setState(state)

    //Set the relevant sub topics accourding to the topic
    var subTopicListNew = [];
    this.state.subTopicListNew = [];
    this.state.subtopic = [];
    this.state.subTopicList.map(function (subTopic, index) {
      console.log(subTopic);
      if (subTopic[1] == e.target.value) {
        subTopicListNew.push(subTopic[0])
      }
    })

    this.setState({
      subTopicListNew: subTopicListNew,
    });
  }

  generatePaperHandler = (e) => {
    e.preventDefault()

    if(this.state.subtopic.length == 0){
      alert("Please fill the sub topic input feild!")
    }
    var area = this.state.area;
    var topic = this.state.topic;
    var subtopic = this.state.subtopic;

    axios.post(constant() + '/questions/' + area + '/' + topic + '/', subtopic)
      .then(response => {
        console.log(response.data)
        this.props.history.push({
          pathname: '/QuestionPaper',
          state: {
            questionList: response.data,
            answerList: [],
            SystemUser: this.state.SystemUser,
            count: 0,
            paperNo: 1,
            area: area,
            topic: topic,
            subtopic: subtopic,
            previouPaperId: this.state.previouPaperId,
            uniqueId: this.state.uniqueId,
          }
        });

      })
      .catch(error => {
        console.log(error)
      })

  }

  backButtonHandler = () => {
    this.props.history.push({
      pathname: '/StudentDashBoard',
      state: {
        SystemUser: this.state.SystemUser,
      }
    });

  }

  logOutButtonHandler = () => {
    this.props.history.push("/")
  }

  handleSubTopic = (event) => {
    this.setState({
      subtopic: event.value
    });
  }


  render() {

    const { areaList, topicList, subTopicListNew, area, topic, subtopic } = this.state;

    return (

      <div className="container">
        <div className="panel panel-default">
          <div className="panel-heading">
            <div className="row">
              <div className="col-md-7">
                <h3 className="panel-title">
                  Student Question Paper Creation
                </h3>
              </div>
              <div className="col-md-3 text-right">
                <button type="submit" className="btn btn btn-outline-primary" onClick={this.backButtonHandler.bind(this)}><FontAwesomeIcon icon={faAngleDoubleLeft} />  Back to Dashboard</button>
              </div>
              <div className="col-md-2">
                <button type="submit" className="btn btn btn-outline-danger" onClick={this.logOutButtonHandler.bind(this)}><FontAwesomeIcon icon={faSignOutAlt} />  Logout</button>
              </div>
            </div>
          </div>
          <div className="panel-body">
            <form onSubmit={this.submitHandler}>
              <div className="form-group">
                <label>Area:</label>
                <select className="form-control" name="area" onChange={this.listHandler} value={area}>
                  {
                    this.state.areaList.map(sub => {
                      return (
                        <option key={sub.id} value={sub.id}>{sub} </option>
                      )
                    })
                  }
                </select>
              </div>
              <div className="form-group">
                <label>Topic:</label>
                <select className="form-control" name="topic" onChange={this.topicHandler} value={topic}>
                  {
                    this.state.topicList.map(sub => {
                      return (
                        <option key={sub.id} value={sub.id}>{sub} </option>
                      )
                    })
                  }
                </select>
              </div>
              <div className="example-wrapper">
                <label>Sub Topic:</label>
                <MultiSelect data={subTopicListNew} onChange={this.handleSubTopic} value={subtopic} />
              </div>
              <button type="submit" className="btn btn btn-outline-success generateBtn" onClick={this.generatePaperHandler.bind(this)}><FontAwesomeIcon icon={faCogs} /> &nbsp; Create</button>
              <button type="reset" className="btn btn-outline-secondary loginBtn"><FontAwesomeIcon icon={faRedoAlt} /> &nbsp;  Reset</button>
            </form>
          </div>
        </div>
      </div>
    )
  }
}

export default Student2