package com.cdap_2020_027.elearning.ws.repository;

import com.cdap_2020_027.elearning.ws.model.PaperResultFinal;
import java.util.List;
import javax.transaction.Transactional;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

/**
 *
 * @author IT17119122 Liyanage I.M
 */
public interface PaperResultFinalRepository extends JpaRepository<PaperResultFinal, Integer>{
    
    @Query(value = "SELECT * FROM paper_result_student_final WHERE SID = ?1 ", nativeQuery = true)
    List<PaperResultFinal> getPapers(int id);
    
    @Query(value = "SELECT * FROM paper_result_student_final WHERE ID = ?1", nativeQuery = true)
    PaperResultFinal getPaper(int id);
    
    @Modifying
    @Transactional
    @Query(value = "update paper_result_student_final set FLAG = ?1 where ID = ?2", nativeQuery = true)
    int updateFlag(String flag,int id);
    
    @Modifying
    @Transactional
    @Query(value = "update paper_result_student_final set FLAG = ?1 where ID = ?2", nativeQuery = true)
    int updateFlagPrevious(String flag,int previouPaperId);
    
//    @Query(value = "SELECT DISTINCT UNIQUE_ID,SUB_TOPIC FROM paper_result_student_final WHERE SID = ?1", nativeQuery = true)
    @Query("SELECT DISTINCT p.uniqueId,p.subtopic FROM PaperResultFinal p WHERE p.sid = ?1")
    List<Object[]> getUniqueIds(int sid);
}
