package com.cdap_2020_027.elearning.ws.repository;

import com.cdap_2020_027.elearning.ws.model.Question;
import java.util.List;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

/**
 *
 * @author IT17119122 Liyanage I.M
 */
public interface QuestionRepository extends JpaRepository<Question, Integer>{
    
    @Query(value = "SELECT DISTINCT AREA FROM question_bank", nativeQuery = true)
    List<String> getQuestionAreas();
    
    @Query(value = "SELECT DISTINCT TOPIC FROM question_bank", nativeQuery = true)
    List<String> getQuestionTopics();
    
    @Query("SELECT DISTINCT b.subTopic,b.topic FROM Question b")
    List<Question> getQuestionSubTopics();
    
    @Query(value = "SELECT * FROM question_bank WHERE AREA = ?1 AND TOPIC = ?2 AND SUB_TOPIC IN ?3 ORDER BY RAND() LIMIT 30", nativeQuery = true)
    List<Question> getQuestionList(String area,String topic,List<String> subtopic);
    
    @Query(value = "SELECT * FROM question_bank WHERE ID = ?1 ", nativeQuery = true)
    Question getQuestion(int id);
}
