package com.cdap_2020_027.elearning.ws.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

/**
 *
 * @author IT17119122 Liyanage I.M
 */
@Component
public class FetchDataIntegration {

    public static String flaskIntegration;

    @Value("${spring.url.flask_integration}")
    public void setUrl(String url) {
        this.flaskIntegration = url;
    }

    public static String fetch(String urlString) throws MalformedURLException, IOException {

        StringBuilder urlBuilder = new StringBuilder();
        urlBuilder.append(flaskIntegration);
        urlBuilder.append(urlString);

        URL url = new URL(urlBuilder.toString());
        HttpURLConnection conn = (HttpURLConnection) url.openConnection();
        conn.setRequestMethod("GET");
        conn.setRequestProperty("Accept", "application/json");

        BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream(), "UTF-8"));
        StringBuilder stringBuilder = new StringBuilder();
        String output = null;

        while ((output = br.readLine()) != null) {
            stringBuilder.append(output);
        }

        conn.disconnect();
        return stringBuilder.toString();
    }
}
